/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package net.darkgamer.games.spacehero.ships;

import net.darkgamer.games.spacehero.lasers.BlueLaser;
import org.anddev.andengine.entity.sprite.Sprite;
import org.anddev.andengine.input.touch.TouchEvent;
import org.anddev.andengine.opengl.texture.TextureOptions;
import org.anddev.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlas;
import org.anddev.andengine.opengl.texture.atlas.bitmap.BitmapTextureAtlasTextureRegionFactory;

/**
 *
 * @author octeaun
 */
public class PlayerShip extends Ship{
    
    public BlueLaser laser1;
    public BlueLaser laser2;
    public BlueLaser laser3;
    public BlueLaser laser4;

    @Override
    public boolean loadRessource() {
        laser1 = new BlueLaser();
        laser1.setContext(this.getContext());
        laser2 = new BlueLaser();
        laser2.setContext(this.getContext());
        laser3 = new BlueLaser();
        laser3.setContext(this.getContext());
        laser4 = new BlueLaser();
        laser4.setContext(this.getContext());
        try {
            this.setmShipBitmapTextureAtlas(new BitmapTextureAtlas(64, 64, TextureOptions.BILINEAR_PREMULTIPLYALPHA));
            this.setmShipTextureRegion(BitmapTextureAtlasTextureRegionFactory.createFromAsset(this.getmShipBitmapTextureAtlas(), this.getContext(), "ship.png", 0, 0));
            this.laser1.LoadRessources();
            this.laser2.LoadRessources();
            this.laser3.LoadRessources();
            this.laser4.LoadRessources();
            return true;
        } catch (Exception e) {
            return false;
        }
    }

    @Override
    public void initShip() {
        this.initShipLasers();
        this.setShipSprite(new Sprite(0, 0, this.getmShipTextureRegion()){
            @Override
            public boolean onAreaTouched(final TouchEvent pSceneTouchEvent, final float pTouchAreaLocalX, final float pTouchAreaLocalY) {
                switch(pSceneTouchEvent.getAction()){
                    case TouchEvent.ACTION_DOWN:
                        laser1.getLaserSystem().setParticlesSpawnEnabled(true);
                        laser2.getLaserSystem().setParticlesSpawnEnabled(true);
                        laser3.getLaserSystem().setParticlesSpawnEnabled(true);
                        laser4.getLaserSystem().setParticlesSpawnEnabled(true);
                        break;
                    case TouchEvent.ACTION_MOVE:
                        this.setPosition(pSceneTouchEvent.getX() - this.getWidth()/2, pSceneTouchEvent.getY() - this.getHeight() / 2);
                        PlayerShip.this.setX(pSceneTouchEvent.getX()- this.getWidth()/2);
                        PlayerShip.this.setY(pSceneTouchEvent.getY()- this.getHeight() / 2);
                        laser1.getLaserEmitter().setCenter(PlayerShip.this.getX()+12,PlayerShip.this.getY()-32);
                        laser2.getLaserEmitter().setCenter(PlayerShip.this.getX()+36, PlayerShip.this.getY()-32);
                        laser3.getLaserEmitter().setCenter(PlayerShip.this.getX()+4, PlayerShip.this.getY()-16);
                        laser4.getLaserEmitter().setCenter(PlayerShip.this.getX()+44, PlayerShip.this.getY()-16);
                        break;
                    case TouchEvent.ACTION_UP:
                        laser1.getLaserSystem().setParticlesSpawnEnabled(false);
                        laser2.getLaserSystem().setParticlesSpawnEnabled(false);
                        laser3.getLaserSystem().setParticlesSpawnEnabled(false);
                        laser4.getLaserSystem().setParticlesSpawnEnabled(false);
                }
                return true;
            }            
        });
    }

    @Override
    public void initShipLasers() {
        laser1.initLaser(this.getX(), this.getY());
        laser2.initLaser(this.getX(), this.getY());
        laser3.initLaser(this.getX(), this.getY());
        laser4.initLaser(this.getX(), this.getY());
    }
    
}
